using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Wo_WorkOrderItem
    /// </summary>
    public partial class T_Wo_WorkOrderItem
    {
        public T_Wo_WorkOrderItem()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(long ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Wo_WorkOrderItem");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.BigInt)
            };
            parameters[0].Value = ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public long Add(CallCenterApi.Model.T_Wo_WorkOrderItem model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Wo_WorkOrderItem(");
            strSql.Append("WorkOrderID,Type,ToUser,ToDept,Detail,Files,Remark,CallID,State,LimitTime,SureTime,DealUser,DealTime,IsLast,IsStart,IsTimeOut,CreateUser,CreateTime,IsDel,DelUser,DelTime,SureUser)");
            strSql.Append(" values (");
            strSql.Append("@WorkOrderID,@Type,@ToUser,@ToDept,@Detail,@Files,@Remark,@CallID,@State,@LimitTime,@SureTime,@DealUser,@DealTime,@IsLast,@IsStart,@IsTimeOut,@CreateUser,@CreateTime,@IsDel,@DelUser,@DelTime,@SureUser)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@WorkOrderID", SqlDbType.VarChar,50),
                    new SqlParameter("@Type", SqlDbType.Int,4),
                    new SqlParameter("@ToUser", SqlDbType.VarChar,50),
                    new SqlParameter("@ToDept", SqlDbType.Int,4),
                    new SqlParameter("@Detail", SqlDbType.NVarChar,-1),
                    new SqlParameter("@Files", SqlDbType.VarChar,-1),
                    new SqlParameter("@Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@CallID", SqlDbType.VarChar,50),
                    new SqlParameter("@State", SqlDbType.Int,4),
                    new SqlParameter("@LimitTime", SqlDbType.Decimal,9),
                    new SqlParameter("@SureTime", SqlDbType.DateTime),
                    new SqlParameter("@DealUser", SqlDbType.VarChar,50),
                    new SqlParameter("@DealTime", SqlDbType.DateTime),
                    new SqlParameter("@IsLast", SqlDbType.Int,4),
                    new SqlParameter("@IsStart", SqlDbType.Int,4),
                    new SqlParameter("@IsTimeOut", SqlDbType.Int,4),
                    new SqlParameter("@CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@IsDel", SqlDbType.Int,4),
                    new SqlParameter("@DelUser", SqlDbType.VarChar,50),
                    new SqlParameter("@DelTime", SqlDbType.DateTime),
                    new SqlParameter("@SureUser", SqlDbType.VarChar,50)};
            parameters[0].Value = model.WorkOrderID;
            parameters[1].Value = model.Type;
            parameters[2].Value = model.ToUser;
            parameters[3].Value = model.ToDept;
            parameters[4].Value = model.Detail;
            parameters[5].Value = model.Files;
            parameters[6].Value = model.Remark;
            parameters[7].Value = model.CallID;
            parameters[8].Value = model.State;
            parameters[9].Value = model.LimitTime;
            parameters[10].Value = model.SureTime;
            parameters[11].Value = model.DealUser;
            parameters[12].Value = model.DealTime;
            parameters[13].Value = model.IsLast;
            parameters[14].Value = model.IsStart;
            parameters[15].Value = model.IsTimeOut;
            parameters[16].Value = model.CreateUser;
            parameters[17].Value = model.CreateTime;
            parameters[18].Value = model.IsDel;
            parameters[19].Value = model.DelUser;
            parameters[20].Value = model.DelTime;
            parameters[21].Value = model.SureUser;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt64(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Wo_WorkOrderItem model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Wo_WorkOrderItem set ");
            strSql.Append("WorkOrderID=@WorkOrderID,");
            strSql.Append("Type=@Type,");
            strSql.Append("ToUser=@ToUser,");
            strSql.Append("ToDept=@ToDept,");
            strSql.Append("Detail=@Detail,");
            strSql.Append("Files=@Files,");
            strSql.Append("Remark=@Remark,");
            strSql.Append("CallID=@CallID,");
            strSql.Append("State=@State,");
            strSql.Append("LimitTime=@LimitTime,");
            strSql.Append("SureTime=@SureTime,");
            strSql.Append("DealUser=@DealUser,");
            strSql.Append("DealTime=@DealTime,");
            strSql.Append("IsLast=@IsLast,");
            strSql.Append("IsStart=@IsStart,");
            strSql.Append("IsTimeOut=@IsTimeOut,");
            strSql.Append("CreateUser=@CreateUser,");
            strSql.Append("CreateTime=@CreateTime,");
            strSql.Append("IsDel=@IsDel,");
            strSql.Append("DelUser=@DelUser,");
            strSql.Append("DelTime=@DelTime,");
            strSql.Append("SureUser=@SureUser");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@WorkOrderID", SqlDbType.VarChar,50),
                    new SqlParameter("@Type", SqlDbType.Int,4),
                    new SqlParameter("@ToUser", SqlDbType.VarChar,50),
                    new SqlParameter("@ToDept", SqlDbType.Int,4),
                    new SqlParameter("@Detail", SqlDbType.NVarChar,-1),
                    new SqlParameter("@Files", SqlDbType.VarChar,-1),
                    new SqlParameter("@Remark", SqlDbType.NVarChar,-1),
                    new SqlParameter("@CallID", SqlDbType.VarChar,50),
                    new SqlParameter("@State", SqlDbType.Int,4),
                    new SqlParameter("@LimitTime", SqlDbType.Decimal,9),
                    new SqlParameter("@SureTime", SqlDbType.DateTime),
                    new SqlParameter("@DealUser", SqlDbType.VarChar,50),
                    new SqlParameter("@DealTime", SqlDbType.DateTime),
                    new SqlParameter("@IsLast", SqlDbType.Int,4),
                    new SqlParameter("@IsStart", SqlDbType.Int,4),
                    new SqlParameter("@IsTimeOut", SqlDbType.Int,4),
                    new SqlParameter("@CreateUser", SqlDbType.VarChar,50),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@IsDel", SqlDbType.Int,4),
                    new SqlParameter("@DelUser", SqlDbType.VarChar,50),
                    new SqlParameter("@DelTime", SqlDbType.DateTime),
                    new SqlParameter("@SureUser", SqlDbType.VarChar,50),
                    new SqlParameter("@ID", SqlDbType.BigInt,8)};
            parameters[0].Value = model.WorkOrderID;
            parameters[1].Value = model.Type;
            parameters[2].Value = model.ToUser;
            parameters[3].Value = model.ToDept;
            parameters[4].Value = model.Detail;
            parameters[5].Value = model.Files;
            parameters[6].Value = model.Remark;
            parameters[7].Value = model.CallID;
            parameters[8].Value = model.State;
            parameters[9].Value = model.LimitTime;
            parameters[10].Value = model.SureTime;
            parameters[11].Value = model.DealUser;
            parameters[12].Value = model.DealTime;
            parameters[13].Value = model.IsLast;
            parameters[14].Value = model.IsStart;
            parameters[15].Value = model.IsTimeOut;
            parameters[16].Value = model.CreateUser;
            parameters[17].Value = model.CreateTime;
            parameters[18].Value = model.IsDel;
            parameters[19].Value = model.DelUser;
            parameters[20].Value = model.DelTime;
            parameters[21].Value = model.SureUser;
            parameters[22].Value = model.ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(long ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_WorkOrderItem ");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.BigInt)
            };
            parameters[0].Value = ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_WorkOrderItem ");
            strSql.Append(" where ID in (" + IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Wo_WorkOrderItem GetModel(long ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 ID,WorkOrderID,Type,ToUser,ToDept,Detail,Files,Remark,CallID,State,LimitTime,SureTime,DealUser,DealTime,IsLast,IsStart,IsTimeOut,CreateUser,CreateTime,IsDel,DelUser,DelTime,SureUser from T_Wo_WorkOrderItem ");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.BigInt)
            };
            parameters[0].Value = ID;

            CallCenterApi.Model.T_Wo_WorkOrderItem model = new CallCenterApi.Model.T_Wo_WorkOrderItem();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Wo_WorkOrderItem DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Wo_WorkOrderItem model = new CallCenterApi.Model.T_Wo_WorkOrderItem();
            if (row != null)
            {
                if (row["ID"] != null && row["ID"].ToString() != "")
                {
                    model.ID = long.Parse(row["ID"].ToString());
                }
                if (row["WorkOrderID"] != null)
                {
                    model.WorkOrderID = row["WorkOrderID"].ToString();
                }
                if (row["Type"] != null && row["Type"].ToString() != "")
                {
                    model.Type = int.Parse(row["Type"].ToString());
                }
                if (row["ToUser"] != null)
                {
                    model.ToUser = row["ToUser"].ToString();
                }
                if (row["ToDept"] != null && row["ToDept"].ToString() != "")
                {
                    model.ToDept = int.Parse(row["ToDept"].ToString());
                }
                if (row["Detail"] != null)
                {
                    model.Detail = row["Detail"].ToString();
                }
                if (row["Files"] != null)
                {
                    model.Files = row["Files"].ToString();
                }
                if (row["Remark"] != null)
                {
                    model.Remark = row["Remark"].ToString();
                }
                if (row["CallID"] != null)
                {
                    model.CallID = row["CallID"].ToString();
                }
                if (row["State"] != null && row["State"].ToString() != "")
                {
                    model.State = int.Parse(row["State"].ToString());
                }
                if (row["LimitTime"] != null && row["LimitTime"].ToString() != "")
                {
                    model.LimitTime = decimal.Parse(row["LimitTime"].ToString());
                }
                if (row["SureTime"] != null && row["SureTime"].ToString() != "")
                {
                    model.SureTime = DateTime.Parse(row["SureTime"].ToString());
                }
                if (row["DealUser"] != null)
                {
                    model.DealUser = row["DealUser"].ToString();
                }
                if (row["DealTime"] != null && row["DealTime"].ToString() != "")
                {
                    model.DealTime = DateTime.Parse(row["DealTime"].ToString());
                }
                if (row["IsLast"] != null && row["IsLast"].ToString() != "")
                {
                    model.IsLast = int.Parse(row["IsLast"].ToString());
                }
                if (row["IsStart"] != null && row["IsStart"].ToString() != "")
                {
                    model.IsStart = int.Parse(row["IsStart"].ToString());
                }
                if (row["IsTimeOut"] != null && row["IsTimeOut"].ToString() != "")
                {
                    model.IsTimeOut = int.Parse(row["IsTimeOut"].ToString());
                }
                if (row["CreateUser"] != null)
                {
                    model.CreateUser = row["CreateUser"].ToString();
                }
                if (row["CreateTime"] != null && row["CreateTime"].ToString() != "")
                {
                    model.CreateTime = DateTime.Parse(row["CreateTime"].ToString());
                }
                if (row["IsDel"] != null && row["IsDel"].ToString() != "")
                {
                    model.IsDel = int.Parse(row["IsDel"].ToString());
                }
                if (row["DelUser"] != null)
                {
                    model.DelUser = row["DelUser"].ToString();
                }
                if (row["DelTime"] != null && row["DelTime"].ToString() != "")
                {
                    model.DelTime = DateTime.Parse(row["DelTime"].ToString());
                }
                if (row["SureUser"] != null)
                {
                    model.SureUser = row["SureUser"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ID,WorkOrderID,Type,ToUser,ToDept,Detail,Files,Remark,CallID,State,LimitTime,SureTime,DealUser,DealTime,IsLast,IsStart,IsTimeOut,CreateUser,CreateTime,IsDel,DelUser,DelTime,SureUser ");
            strSql.Append(" FROM T_Wo_WorkOrderItem ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" ID,WorkOrderID,Type,ToUser,ToDept,Detail,Files,Remark,CallID,State,LimitTime,SureTime,DealUser,DealTime,IsLast,IsStart,IsTimeOut,CreateUser,CreateTime,IsDel,DelUser,DelTime,SureUser ");
            strSql.Append(" FROM T_Wo_WorkOrderItem ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Wo_WorkOrderItem ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Wo_WorkOrderItem T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Wo_WorkOrderItem";
			parameters[1].Value = "ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

